require "System.camera"
--require "System.player"
--var Graphics--
imgPlayer = nil
menuNewGameClick = nil
menuLoadGameClick = nil
menuHighScoreClick = nil
menuOptionsClick = nil
menuQuitClick = nil
menuNewGameMenuReturnClick = nil
menuNewOnePlayer = nil
buttonStartGame = nil
mouseCursor = nil
gamePlatform = nil

fontMain = nil
fontInGame = nil
--var Game State--
gameState = "mainMenu"
--var Bool--
boolMouseUsed = false
--Output--
mouseCursor = nil
--Objects--
--System Variables
--gravity = nil
worldLength = nil

function love.load(arg)
	-- System--
	love.mouse.setVisible(false)
	love.physics.setMeter(32)
	world = love.physics.newWorld(0, 9.81 * 32, true) -- X gravty Axis, Y Gravity Axis, Objects can sleep?
	world:setCallbacks(beginContact,endContact, preSolve, postSolve)
	objects = {} -- all the objects here
	--love.mouse.setGrabbed(true) --Activate Later
	--load Fonts--
	fontMain = love.graphics.setNewFont("Fonts/aesymatt.ttf",30)--file, size--
	fontInGame = love.graphics.newFont("Fonts/aesymatt.ttf",20)
	--load Graphics Main Menu--
	imgPlayer = love.graphics.newImage("Graphics/player.png")
	menuNewGameClick = {x = 425 , y = 250 , img =  love.graphics.newImage("Graphics/menuClick.png")} 
	menuLoadGameClick = {x = 425, y = 300 , img = love.graphics.newImage("Graphics/menuClick.png")}
	menuHighScoreClick = {x= 425, y = 350, img = love.graphics.newImage("Graphics/menuClick.png")}
	menuOptionsClick = {x = 425, y = 450, img = love.graphics.newImage("Graphics/menuClick.png")} 
	menuQuitClick = {x = 425, y = 500, img = love.graphics.newImage("Graphics/menuClick.png")}
	mouseCursor = {img = love.graphics.newImage("Graphics/mouseCursor.png")}
	--Load Graphics Main New Game
	menuNewGameMenuReturnClick = {x = 425, y = 450, img = love.graphics.newImage("Graphics/menuClick.png")}
	menuNewOnePlayer = {x = 425, y = 250, img = love.graphics.newImage("Graphics/menuClick.png")}
	buttonStartGame = {x = 900, y = 698 , img = love.graphics.newImage("Graphics/buttonSmall.png")}
	--Output--
	--Ingame--
	--gamePlatform = { x = 500, y = 400, img = love.graphics.newImage("Graphics/menuClick.png"), w = 150, h = 32 }
	worldLength = 300 -- how Long the World will be
	--gravity = 400
end

function love.update(dt)
	if gameState == "THEGAME" then
		world:update(dt)
		camera.x = objects.player.body:getX() - 1024/2
		if objects.player.hp <= 0 then --DEAD
			objects.player.alive = false
		end
		--if love.keyboard.isDown("d") then
		--	player.x = player.x + (150 * dt)
		--end
		--if love.keyboard.isDown("a") then
		--	player.x = player.x - (150 * dt)
		--end
		--if player.y_velocity ~= gamePlatform.y - player.img:getHeight() then -- we're probably jumping
		--player.y = player.y - player.y_velocity * dt -- dt means we wont move at
		-- different speeds if the game lags
		--player.y_velocity = player.y_velocity - gravity * dt
		--if player.y > gamePlatform.y - player.img:getHeight() then -- we hit the ground again
		--	player.y_velocity = gamePlatform.y - player.img:getHeight()
		--	player.y = gamePlatform.y - player.img:getHeight()
		--end
	--end
		if objects.player.alive == true then
			xVel, yVel =  objects.player.body:getLinearVelocity()
			if love.keyboard.isDown("d") and love.keyboard.isDown("a") and yVel == 0 then
				objects.player.body:setLinearVelocity(0, 0)
			elseif love.keyboard.isDown("d") then --press the right arrow key to push the ball to the right
    			objects.player.body:applyForce(400, 0)
  			elseif love.keyboard.isDown("a") then --press the left arrow key to push the ball to the left
    			objects.player.body:applyForce(-400, 0)
  			elseif love.keyboard.isDown("r") then --press the up arrow key to set the ball in the air
    			objects.player.body:setPosition(650/2, 650/2)
    			objects.player.body:setLinearVelocity(0, 0) --we must set the velocity to zero to prevent a potentially large velocity generated by the change in position
    		else
    			if yVel == 0 then
    		 	objects.player.body:setLinearVelocity(0, 0)
    			end
  			end
  			if love.keyboard.isDown("w") and yVel == 0 then
  				objects.player.body:applyForce(0, -10000)
  			end
  			if xVel > 350 then
				objects.player.body:setLinearVelocity(350,yVel)
			end
			if xVel < -350 then
				objects.player.body:setLinearVelocity(-350,yVel)
			end
		end
	end
end

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function ResetGame()

	world = love.physics.newWorld(0, 9.81 * 32, true) -- X gravty Axis, Y Gravity Axis, Objects can sleep?
	world:setCallbacks(beginContact,endContact, preSolve, postSolve)
	objects = {} -- all the objects here
	--player = Player.newPlayer("fghdfgh", imgPlayer, dt)
	--create a ground--
	objects.player = {}
	objects.player.body = love.physics.newBody(world, 200, 200, "dynamic")
	objects.player.shape = love.physics.newCircleShape(16)
	objects.player.fixture = love.physics.newFixture(objects.player.body,objects.player.shape)
	objects.player.fixture:setUserData("player")
	objects.player.alive = true
	objects.player.hp = 10

	--objects.ground = {}
	--objects.ground.body = love.physics.newBody(world, 650/2, 650-50/2 )
	--objects.ground.shape = love.physics.newRectangleShape(650,50)
	--objects.ground.fixture = love.physics.newFixture(objects.ground.body, objects.ground.shape) --attach shape to body
	GroundGenerate()
	EnemyCreate()
end

function GroundGenerate()
	objects.groundGenerate = {}
	objects.spikes = {} --SPIKES
	groundHeight = 672
	groundHeightChange = 0
	spikeChance = 0
	spikeQuantity = 0
	spikeGeneratePosition = {} 
	for i = 1, worldLength, 1 do
		groundHeightChange = love.math.random ( 1, 10)
		spikeChance = love.math.random ( 1, 20)
		if groundHeightChange == 1 then
			groundHeight = groundHeight +32
		end
		if groundHeightChange == 10 then
			groundHeight = groundHeight - 32
		end
  		objects.groundGenerate[i] = {}
  		objects.groundGenerate[i].body = love.physics.newBody(world, (32*i-32), groundHeight-32/2 )
  		objects.groundGenerate[i].shape = love.physics.newRectangleShape( 32, 32)
  		objects.groundGenerate[i].fixture = love.physics.newFixture(objects.groundGenerate[i].body, objects.groundGenerate[i].shape)

  		if spikeChance == 19 then	
  			spikeQuantity = spikeQuantity +1
  			spikeGeneratePosition[spikeQuantity] = {x = 32*i -32, y =  groundHeight -32 -32/2 }
		end  	
	end

	for i = 1, spikeQuantity, 1 do
		objects.spikes[i] = {}
  		objects.spikes[i].body = love.physics.newBody(world, spikeGeneratePosition[i].x,spikeGeneratePosition[i].y)
  		objects.spikes[i].shape = love.physics.newRectangleShape( 32, 16)
  		objects.spikes[i].fixture = love.physics.newFixture(objects.spikes[i].body, objects.spikes[i].shape)
  		objects.spikes[i].fixture:setUserData("spike")
  	end
end

function EnemyCreate()
	objects.enemy = {}
	objects.enemy.body = love.physics.newBody(world, 400, 200, "dynamic")
	objects.enemy.shape = love.physics.newCircleShape(16)
	objects.enemy.fixture = love.physics.newFixture(objects.enemy.body,objects.enemy.shape)
	--objects.enemy.fixture:setFriction(0.9)
	objects.enemy.fixture:setUserData("enemy")
end

function love.mousepressed(x,y,button)
	if button == 1 then
		if gameState == "newGameMenu" then
			if CheckCollision(x, y, mouseCursor.img:getWidth(), mouseCursor.img:getHeight(), menuNewOnePlayer.x, menuNewOnePlayer.y, menuNewOnePlayer.img:getWidth(), menuNewOnePlayer.img:getHeight()) then
				ResetGame()
				gameState = "newOnePlayer"		
			end
			if CheckCollision(x, y, mouseCursor.img:getWidth(), mouseCursor.img:getHeight(), menuNewGameMenuReturnClick.x, menuNewGameMenuReturnClick.y, menuNewGameMenuReturnClick.img:getWidth(), menuNewGameMenuReturnClick.img:getHeight()) then
				gameState = "mainMenu"		
			end
		end
		if gameState == "newOnePlayer" then
			if CheckCollision(x, y, mouseCursor.img:getWidth(), mouseCursor.img:getHeight(), buttonStartGame.x, buttonStartGame.y, buttonStartGame.img:getWidth(), buttonStartGame.img:getHeight()) then
				gameState = "THEGAME"
			end
		end
		if gameState == "mainMenu" then
			if CheckCollision(x, y, mouseCursor.img:getWidth(), mouseCursor.img:getHeight(), menuNewGameClick.x, menuNewGameClick.y, menuNewGameClick.img:getWidth(), menuNewGameClick.img:getHeight()) then
				gameState = "newGameMenu" 
			end
			if CheckCollision(x, y, mouseCursor.img:getWidth(), mouseCursor.img:getHeight(), menuQuitClick.x, menuQuitClick.y, menuQuitClick.img:getWidth(), menuQuitClick.img:getHeight()) then
				love.event.quit()
			end
		end
	end
end

function love.keypressed(key)
	if gameState == "THEGAME" then
		if objects.player.alive == false then
			if key == "y" then
				ResetGame()
			end
			if key == "n" then
				gameState = "mainMenu"
			end
		end
		--if key == "w" then
		--	xVel, yVel =  objects.player.body:getLinearVelocity()
		--	if yVel == 0 then
    	--		objects.player.body:applyForce(0, -10000)
    	--	end
		--if player.y_velocity == gamePlatform.y - player.img:getHeight() then -- we're probably on the ground, let's jump
		--	player.y_velocity = player.jump_height
		--end
		--end
	end
end

function love.keyreleased(key)
	if gameState == "THEGAME" then
		if key == "a" or key == "d" then
			xVel, yVel =  objects.player.body:getLinearVelocity()
			--if yVel == 0 then
				objects.player.body:setLinearVelocity(0, yVel)
			--end
		end
	end
end

function beginContact(a, b, coll)
	if a:getUserData() == "player" then
		if b:getUserData() == "enemy" then
			objects.player.hp = objects.player.hp - 5
		end
	end
end
 
function endContact(a, b, coll)
 
end
 
function preSolve(a, b, coll)
	if a:getUserData() == "player" then
		if b:getUserData() == "spike" then
			coll:setEnable(false)
		end
	end
end
 
function postSolve(a, b, coll, normalimpulse1, tangentimpulse1, normalimpulse2, tangentimpulse2)
 
end

function love.draw(dt)
	if gameState == "THEGAME" then
		--player.drawCharacter()
		--love.graphics.draw(gamePlatform.img, gamePlatform.x, gamePlatform.y)
		--love.graphics.print("X: " .. love.mouse.getX() .. "/ Y: " .. love.mouse.getY(),100,140)
		--love.graphics.setColor(72, 160, 14) -- set the drawin
		love.graphics.print("HP: " .. objects.player.hp, 50, 50)
		camera:set()
		for i = 1, worldLength, 1 do
			love.graphics.polygon("fill",objects.groundGenerate[i].body:getWorldPoints(objects.groundGenerate[i].shape:getPoints()))
		end
		for i = 1, spikeQuantity, 1 do
			 love.graphics.polygon("fill",objects.spikes[i].body:getWorldPoints(objects.spikes[i].shape:getPoints()))
		end
  		--love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints())) -- draw a "filled in" polygon using the ground's coordinates
  		love.graphics.circle("fill", objects.enemy.body:getX(),objects.enemy.body:getY(), objects.enemy.shape:getRadius())
		love.graphics.circle("fill", objects.player.body:getX(),objects.player.body:getY(), objects.player.shape:getRadius())
		love.graphics.draw(imgPlayer,objects.player.body:getX()-16,objects.player.body:getY()-16)
		camera:unset()	
		if objects.player.alive == false then
			love.graphics.setFont(fontMain)
			love.graphics.printf("You Died, continue?", 400, 250, 300, "center")
			love.graphics.setFont(fontInGame)
			love.graphics.printf("Y/N", 400, 300, 200, "center")
		end
	end

	if gameState == "mainMenu" then
		love.graphics.setFont(fontMain)		
		love.graphics.draw(menuNewGameClick.img ,menuNewGameClick.x, menuNewGameClick.y)
		love.graphics.printf("New Game", 400, 250, 200, "center")

		love.graphics.draw(menuLoadGameClick.img, menuLoadGameClick.x, menuLoadGameClick.y)
		love.graphics.printf("Load Game", 400, 300, 200, "center")

		love.graphics.draw(menuHighScoreClick.img, menuHighScoreClick.x, menuHighScoreClick.y)
		love.graphics.printf("High-Score", 400, 350, 200, "center")

		love.graphics.draw(menuOptionsClick.img, menuOptionsClick.x, menuOptionsClick.y)
		love.graphics.printf("Options", 400, 450, 200, "center")

		love.graphics.draw(menuQuitClick.img, menuQuitClick.x, menuQuitClick.y)
		love.graphics.printf("Quit", 400, 500, 200, "center")
	end
	if gameState == "newGameMenu" then
		love.graphics.printf("New Game", 400, 150, 200, "center")

		love.graphics.draw(menuNewOnePlayer.img, menuNewOnePlayer.x, menuNewOnePlayer.y)
		love.graphics.printf("One Player", 400, 250, 200, "center")
		love.graphics.draw(menuNewGameMenuReturnClick.img, menuNewGameMenuReturnClick.x, menuNewGameMenuReturnClick.y)
		love.graphics.printf("Return", 400, 450, 200, "center")
	end
	if gameState == "newOnePlayer" then
		love.graphics.setFont(fontInGame)
		--player.draw()
		love.graphics.draw(buttonStartGame.img, buttonStartGame.x, buttonStartGame.y)
		love.graphics.printf("Start", 900, 700, 80, "center")
	end
	love.graphics.draw(mouseCursor.img, love.mouse.getX(), love.mouse.getY())
	boolMouseUsed = false
end
